#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1300four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1300four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four13004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four13004xi = {
                1:'1005x-29y823z',
                2:'1007x-815y100z',
                3:'1024x-429y674z',
                4:'1049x-762y87z',
                5:'105x-256y1270z',
                6:'105x-64y1294z',
                7:'1088x-706y74z',
                8:'1124x-649y61z',
                9:'1132x-406y714z',
                10:'1157x-589y48z',
                11:'1187x-528y35z',
                12:'119x-64y1292z',
                13:'1213x-465y22z',
                14:'1236x-401y9z',
                15:'124x-261y1267z',
                16:'132x-1259y292z',
                17:'134x-63y1291z',
                18:'144x-265y1264z',
                19:'149x-61y1289z',
                20:'164x-268y1261z',
                21:'164x-58y1288z',
                22:'180x-52y1286z',
                23:'185x-270y1258z',
                24:'195x-46y1284z',
                25:'198x-1253y280z',
                26:'207x-270y1254z',
                27:'209x-38y1282z',
                28:'212x-517y1173z',
                29:'224x-29y1280z',
                30:'229x-268y1251z',
                31:'238x-18y1277z',
                32:'244x-516y1167z',
                33:'251x-265y1247z',
                34:'251x-6y1275z',
                35:'264x-1244y267z',
                36:'273x-260y1243z',
                37:'276x-512y1162z',
                38:'296x-253y1240z',
                39:'309x-507y1156z',
                40:'319x-245y1236z',
                41:'329x-1231y254z',
                42:'341x-235y1232z',
                43:'342x-500y1150z',
                44:'347x-734y1015z',
                45:'364x-223y1227z',
                46:'374x-490y1144z',
                47:'386x-209y1223z',
                48:'389x-724y1006z',
                49:'394x-1214y241z',
                50:'407x-194y1219z',
                51:'407x-479y1137z',
                52:'428x-177y1214z',
                53:'432x-711y998z',
                54:'439x-465y1131z',
                55:'448x-159y1209z',
                56:'458x-1194y229z',
                57:'467x-138y1204z',
                58:'471x-449y1125z',
                59:'474x-695y990z',
                60:'479x-893y813z',
                61:'486x-116y1199z',
                62:'502x-431y1118z',
                63:'503x-93y1194z',
                64:'516x-677y981z',
                65:'519x-68y1189z',
                66:'521x-1171y216z',
                67:'530x-873y803z',
                68:'533x-411y1111z',
                69:'534x-42y1184z',
                70:'547x-14y1179z',
                71:'557x-657y973z',
                72:'563x-389y1104z',
                73:'579x-851y792z',
                74:'582x-1144y203z',
                75:'592x-364y1098z',
                76:'597x-634y964z',
                77:'620x-338y1091z',
                78:'628x-826y782z',
                79:'637x-608y955z',
                80:'642x-1113y190z',
                81:'647x-310y1083z',
                82:'66x-1261y305z',
                83:'672x-280y1076z',
                84:'675x-580y946z',
                85:'675x-798y772z',
                86:'696x-248y1069z',
                87:'701x-1080y177z',
                88:'712x-550y937z',
                89:'718x-214y1061z',
                90:'721x-767y761z',
                91:'739x-179y1054z',
                92:'747x-517y928z',
                93:'757x-1043y164z',
                94:'757x-142y1046z',
                95:'766x-733y751z',
                96:'774x-103y1038z',
                97:'77x-59y1296z',
                98:'781x-482y919z',
                99:'789x-63y1031z',
                100:'801x-22y1023z',
                101:'809x-697y740z',
                102:'812x-1003y152z',
                103:'813x-445y910z',
                104:'844x-406y901z',
                105:'850x-658y729z',
                106:'864x-960y139z',
                107:'872x-365y891z',
                108:'889x-617y718z',
                109:'88x-249y1272z',
                110:'898x-321y882z',
                111:'90x-62y1295z',
                112:'914x-914y126z',
                113:'922x-276y872z',
                114:'927x-573y708z',
                115:'944x-230y862z',
                116:'962x-527y697z',
                117:'962x-866y113z',
                118:'963x-182y853z',
                119:'980x-132y843z',
                120:'994x-479y686z',
                121:'994x-81y833z'}#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1300four4xi" usage = "target function for charge13004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1300four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1300FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1300FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1300FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1300FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1300FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four13004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1300FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1300FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1300FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four13004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four13004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1300FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1300FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1300FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1300four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                   